/*****************************************************************************
 * Bison/Flexプログラム部分をテストするための、Windowsアプリケーションの雛型 *
 * □ビルド・実行方法:                                                       *
 * ┃"C:\Program Files (x86)\Microsoft Visual Studio\VC98\Bin\VCVARS32.BAT"  *
 * ┃make -f winapp.mk run                                                   *
 *****************************************************************************/
#include "winapp.h"
//-----------------------------------------------------------------------------
//警告定義
enum {
	WARN_CAST,			//暗黙の型変換で誤差が生じたら、警告を表示し最終的にエラー終了します。このオプションを指定しなければ、警告表示もエラー終了もしません。
};
static const char* const warn_tokens[]={
	"cast",				//暗黙の型変換で誤差が生じたら、警告を表示し最終的にエラー終了します。このオプションを指定しなければ、警告表示もエラー終了もしません。
NULL};//終端
int warn;				//各警告(WARN_*)について(warn&(1<<WARN_*))がセットされていたらその警告がOnである事を示します。
/*---------------------------------------------------------------------------*/
#define Label_Max	  50000		//ラベル登録最大数	//調整可
#define Inst_Max	1000000		//命令登録最大数	//調整可
typedef struct _ST_Inst {
	unsigned short	line;		//行番号		//1パス目で格納する。エラーメッセージのためだけに使用する。
	unsigned short	wait_cnt;	//ウェイト数		//1パス目で格納する。
	unsigned short	event_id;	//イベントID		//1パス目で格納する。		//{{2016/10/10コメント追加:イベント名が指定された場合は、1パス目ではevent_id=0のままとしておき、2パス目で各イベント名にID(1～)を割り振った後で、event_idを格納する。}}
//{{2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
	char*		event_name;	//イベント名		//1パス目で格納する。		イベント名が指定されていない場合は、event_name=NULLのままとする。
//}}2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
} ST_Inst;
static ST_Inst TBL_Inst[Inst_Max];	//命令配列
static int nInst;			//命令配列の格納数
static char* TBL_Label[Label_Max];	//ラベル配列
static int nLabel;			//ラベル配列の格納数
static int iRepeat = -1;		//ループ戻り位置の命令インデクス	defが現れたら無効値(-1)を格納する。repeatが現れたら命令インデクス(0～)をセットする。	ループ構造の構文エラーはy.tab.yで検出出来るので、winapp.cはiRepeatの正当性を確認しなくて良い。
					//					初期値を(-1)にしておかないと、main()から呼び出されたダミーのinst_end()がエラーになってしまう。
//{{2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
//イベント名
#define EvtName_Max	SHRT_MAX	//イベント名登録最大数
static char* TBL_EvtName[EvtName_Max];	//イベント名配列
static int nEvtName;			//イベント名配列の格納数
//}}2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
//ラベル名のソート方法
int (*fnLabCmp)(const void*, const void*) = strcmp;	//'n',又は,'nl'オプションが指定されたらstrnatcmpに変更する。
//{{2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
int (*fnEvtCmp)(const void*, const void*) = strcmp;	//'n',又は,'ne'オプションが指定されたらstrnatcmpに変更する。
//}}2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
/****************************************************************************
 *	エラーログ用
 ****************************************************************************/
static char err_path[_MAX_PATH];	//'-e'オプションが指定されたら、エラーログファイル名を格納する。
static FILE* fp_err;			//最初のエラーログを記録する時に、エラーログファイルを作成する。
//{{2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
typedef struct _ST_Location {
	const char*	path;					//push_location()が呼び出された直前のファイル名
	int		line;					//push_location()が呼び出された直前の行番号
} ST_Location;
static ST_Location TBL_Location[16/*調整可*/];			//ロケーションスタック
static nLocation;						//ロケーションスタックの格納数
static const char* filename = "-";				//現在のファイル名(popen時はコマンド名)。現在の行番号はyylinenoを参照して下さい。
static void init_location(const char* path) {
	nLocation = 0;						//ロケーションスタックを空にする。
	filename = strdup(path);				//現在のファイル名をコピーして保持する。
	yylineno = 1;						//現在の行番号を初期化する。	yylex_init()でも初期化しているのでこの行は無くても構わないのだが、判り易さのためにここでも初期化する事にした。
}
void push_location(const char* path) {
	if(nLocation >= ARRAY_SIZE(TBL_Location)) { DIE(); }	//ロケーションスタックがフルでない事を確認する。
	TBL_Location[nLocation].path = filename;		//現在のファイル名をロケーションスタックに退避する。
	TBL_Location[nLocation].line = yylineno;		//現在の行番号をロケーションスタックに退避する。
	nLocation++;						//ロケーションスタックの格納数を増やす。
	filename = strdup(path);				//現在のファイル名をコピーして保持する。
	yylineno = 1;						//現在の行番号を初期化する。
}
void pop_location() {
	if(!nLocation) { DIE(); }				//ロケーションスタックが空でない事を確認する。
	nLocation--;						//ロケーションスタックの格納数を減らす。
	filename = TBL_Location[nLocation].path;		//現在のファイル名をロケーションスタックから復元する。
	yylineno = TBL_Location[nLocation].line;		//現在の行番号をロケーションスタックから復元する。
}
//}}2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
void yyerror(const char* fmt, ...) {	//←{{2015/03/06:'-e'オプション対応のためにwinapp.cから移動しました。}}
	//'-e'オプションが指定されていて、最初のエラーログを記録する時ならば…
	if(*err_path && !fp_err) {
		//エラーログファイルを作成する。
		fp_err = fopen(err_path, "w");
		if(!fp_err) { error(EXIT_FAILURE, errno, "%s が作成できません。", err_path); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
		//エラーログファイルの出力ストリームは、バッファリング無しとする。
		// - die()で終了した時(abort()時)に、バッファ分がフラッシュされないようなので、こうしておく必要が有る。
		//   別の案として、この下の処理で毎回fflush()する方法も有るが、バッファリング無しとする方が簡単だろう。
		setbuf(fp_err, NULL);
	}
	//エラーメッセージ(,及び,エラーログ)を出力する。
//{{2016/09/24変更:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
//	             fprintf(stderr, "### error at line %d : ", yylineno);	//エラーメッセージ
//	if(fp_err) { fprintf(fp_err, "### error at line %d : ", yylineno); }	//エラーログ
//↓2016/09/24変更:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
	             fprintf(stderr, "%s(%d) : ", filename, yylineno);		//エラーメッセージ
	if(fp_err) { fprintf(fp_err, "%s(%d) : ", filename, yylineno); }	//エラーログ
//}}2016/09/24変更:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
	{
		va_list ap;
		va_start(ap, fmt);
		             vfprintf(stderr, fmt, ap);		//エラーメッセージ
		if(fp_err) { vfprintf(fp_err, fmt, ap); }	//エラーログ
		va_end(ap);
	}
	             fputc('\n', stderr);	//エラーメッセージ
	if(fp_err) { fputc('\n', fp_err); }	//エラーログ
}
/****************************************************************************
 *	ローカル関数宣言
 ****************************************************************************/
__declspec(noreturn) static void usage();
static int subr(int argc, char* argv[]);
static ST_Inst* add_inst();
static void pass2(int bOptimize);
static void optimize();
static void output(char* sBinOut);
/****************************************************************************
 *	
 ****************************************************************************/
int main(int argc, char* argv[]) {
	int exitCode;
	SEH_init();
	exitCode = subr(argc, argv);
	return exitCode;
}
/*---------------------------------------------------------------------------*/
static int subr(int argc, char* argv[]) {
	int opt, bOptimize = 1;	//'-d'オプションが指定されなければ最適化を行う。
	char* sBinOut = NULL;	//'-o'オプションが指定されたらバイナリ出力ファイル名を設定する。
#if     (YYDEBUG!=0)
//	yydebug = 1; //nonzero means print parse trace
#endif/*(YYDEBUG!=0)*/
	//コマンドラインオプションを処理する。
	opterr = 0; //オプションエラーは当プログラム内で処理するので、getopt()内でのエラー表示は不要。
	while((opt = getopt(argc, argv, "do:en::w::qh")) != -1) {
		switch(opt) {
		case 'd':
			bOptimize = 0;		//最適化を行わない。
			break;
		case 'o':
			sBinOut = optarg;	//バイナリ出力ファイル名を設定する。
			break;
		case 'e':
			{
				//エラーログファイル名を作成する。
				// - カレントフォルダに'実行ファイル名.err'という名前で生成する事にした。この動作は、'lk33.exe'の仕様を参考にした。
				char fname[_MAX_FNAME];
				_splitpath(argv[0], NULL, NULL, fname, NULL);
				_makepath(err_path, NULL, NULL, fname, ".err");
				//'-e'オプションが指定されたら、最初に確実に、既存のエラーログファイルを削除しておく。
				//前回に生成したエラーログが残っていて、今回生成したエラーログと混同する危険を避けるためである。
				//尚、'-e'オプションが指定されなかった場合は、既存のエラーログファイルを削除する処理は行わない。
				remove(err_path);
			}
			break;
		case 'n':
//{{2016/10/10変更:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
//			fnLabCmp = strnatcmp;	//ラベル名のソートにstrnatcmp()を使用する。
//↓2016/10/10変更:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
			if(optarg) {
				     if(!strcmp(optarg, "l")) { fnLabCmp = strnatcmp; }	//ラベル名のソートにstrnatcmp()を使用する。
				else if(!strcmp(optarg, "e")) { fnEvtCmp = strnatcmp; }	//イベント名のソートにstrnatcmp()を使用する。
				else { usage(); }
			} else {
				fnLabCmp = fnEvtCmp = strnatcmp;	//ラベル名とイベント名のソートにstrnatcmp()を使用する。
			}
//}}2016/10/10変更:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
			break;
		case 'w':
			if(optarg) {
				char *optionp = optarg, *valuep;
				while(*optionp) {
					switch(getsubopt(&optionp, (char* const*)warn_tokens, &valuep)) {
					case WARN_CAST:
						if(valuep) { usage(); }
						warn |= (1<<WARN_CAST);
						break;
					default:
						usage();
					}
				}
			} else {
				warn = -1;
			}
			break;
		case 'q':
			/** no job **/	//winapp.hの'Fri Sep 16 21:30:10 JST 2016'のコメントを参照して下さい。
			break;
		case 'h':
		default:
			usage();
		}
	}
	//ラベルを登録するためのハッシュテーブルを作成する。
	hcreate(Label_Max);
	//判り易さのために、命令位置0は使用しないことにした。命令位置0には、ダミーのend命令を置くことにした。
	inst_end();
	//--- 1パス目の処理 ---
	//ファイルが指定されていなければ、標準入力から読み込む。
	if(optind == argc) {
		init_location("-");	//{{2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。}}
		yylex_init(stdin);
	    //{{2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
	    //	if((yyparse() != 0) || (yynerrs != 0)) { die("エラーが発生しました。\n"); }
	    //↓2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
		if((yyparse() != 0) /*|| (yynerrs != 0)*/) { error(EXIT_FAILURE, 0, "エラーが発生しました。"); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
	    //}}2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
	//ファイルが指定されていたら、各ファイルを読み込む。
	} else {
		int i;
		for(i = optind; i < argc; i++) {
			FILE* fp = fopen(argv[i], "r");
			if(!fp) { error(EXIT_FAILURE, errno, "%s が開けません。", argv[i]); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
			init_location(argv[i]);	//{{2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。}}
			yylex_init(fp);
		    //{{2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
		    //	if((yyparse() != 0) || (yynerrs != 0)) { die("%s: エラーが発生しました。\n", argv[i]); }
		    //↓2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
//{{2017/03/16変更:複数の入力ファイルを指定した時に、最後以外のファイルでエラーが発生した場合、当ツールの終了ステータスが0になっていたバグを修正しました。
//			if((yyparse() != 0) /*|| (yynerrs != 0)*/) { error(EXIT_FAILURE, 0, "%s: エラーが発生しました。", argv[i]); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
//↓2017/03/16変更:複数の入力ファイルを指定した時に、最後以外のファイルでエラーが発生した場合、当ツールの終了ステータスが0になっていたバグを修正しました。
			{
				int save_yynerrs = yynerrs;	//yyparse()がyynerrsをクリアするので、その前に現在のyynerrsを保存しておく。
				if((yyparse() != 0) /*|| (yynerrs != 0)*/) { error(EXIT_FAILURE, 0, "%s: エラーが発生しました。", argv[i]); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
				yynerrs += save_yynerrs;	//今回のyyparse()が0から数えたであろうyynerrsに対して、先ほど保存しておいたyynerrsを足し込む。
			}
//}}2017/03/16変更:複数の入力ファイルを指定した時に、最後以外のファイルでエラーが発生した場合、当ツールの終了ステータスが0になっていたバグを修正しました。
		    //}}2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
			fclose(fp);
		}
	}
	//1パス目の処理でエラーが発生しても、2パス目の処理を行って、全てのセマンティクスエラーを報告する。
	//--- 2パス目の処理 ---
	pass2(bOptimize);
	if(yynerrs != 0) { error(EXIT_FAILURE, 0, "エラーが発生しました。"); }	//1パス目,又は,2パス目の処理でエラーが発生していたら、出力処理を行わない。	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
	//--- 出力処理 ---
	output(sBinOut);
	if(yynerrs != 0) { error(EXIT_FAILURE, 0, "エラーが発生しました。"); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
	return EXIT_SUCCESS;
}
/*---------------------------------------------------------------------------*/
//使い方を表示して終了する。
__declspec(noreturn) static void usage() {
	fprintf(stderr, "dEvtTmrC - イベントタイマコンパイラ (%s)\n", VERSION);
	fprintf(stderr, "Copyright (C) 2015-2017 Naoyuki Sawa\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "USAGE:\n");
	fprintf(stderr, "  dEvtTmrC [option ...] [filename ...] \n");
	fprintf(stderr, "  ・filenameを指定しなければ、標準入力から読み込みます。\n");
	fprintf(stderr, "  ・filenameは、ワイルドカードによる複数指定も可能です。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "OPTIONS:\n");
	fprintf(stderr, "  -d           最適化を行いません。\n");
	fprintf(stderr, "               このオプションを指定しなければ、最適化を行います。\n");
	fprintf(stderr, "  -oファイル名 イベント制御のバイナリデータを、バイナリ形式でファイルへ出力します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、Cソース形式で標準出力へ出力します。\n");
	fprintf(stderr, "               このオプションの指定に関らず、ラベルは常に標準出力へ出力します。\n");
	fprintf(stderr, "  -e           エラーログファイルを生成します。\n");
	fprintf(stderr, "               このオプションを指定しても、エラーが発生しなければ生成されません。\n");
//{{2016/10/10変更:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
//	fprintf(stderr, "  -n           ラベル名のソートに、strnatcmp()を使用します。\n");
//	fprintf(stderr, "               このオプションを指定しなければ、strcmp()を使用します。\n");
//↓2016/10/10変更:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
	fprintf(stderr, "  -n           ラベル名とイベント名のソートに、strnatcmp()を使用します。\n");
	fprintf(stderr, "  -nl          ラベル名のソートに、strnatcmp()を使用します。\n");
	fprintf(stderr, "  -ne          イベント名のソートに、strnatcmp()を使用します。\n");
	fprintf(stderr, "               これらのオプションを指定しなければ、strcmp()を使用します。\n");
//}}2016/10/10変更:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
	fprintf(stderr, "  -w           全ての警告を有効にします。\n");
	fprintf(stderr, "               このオプションを指定しなければ、個別に設定した警告のみが有効になります。\n");
	fprintf(stderr, "  -wcast       暗黙の型変換で誤差が生じたら、警告を表示し最終的にエラー終了します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、警告表示もエラー終了もしません。\n");
	fprintf(stderr, "  -q           進捗表示を抑制します。\n");
	fprintf(stderr, "  -h           使い方を表示します。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "EXAMPLE:\n");
	fprintf(stderr, "  ①dEvtTmrC.exe EvtTmr.txt > EvtTmr.c\n");
	fprintf(stderr, "  　EvtTmr.txtをコンパイルして、EvtTmr.cへ出力します。\n");
	fprintf(stderr, "  ②dEvtTmrC.exe -oEvtTmr.bin EvtTmr.txt > EvtTmr.h\n");
	fprintf(stderr, "  　EvtTmr.txtをコンパイルして、ラベルをEvtTmr.hへ出力します。\n");
	fprintf(stderr, "  　イベント制御のバイナリデータを、EvtTmr.binへ出力します。\n");
	exit(EXIT_FAILURE);
}
/****************************************************************************
 *	1パス目の処理
 ****************************************************************************/
int cast_dbl_to_int(double d) {
	int i = d;
	if(i != d) {
		if(warn & (1<<WARN_CAST)) {
			yyerror("切り捨て誤差が発生しました: %f → %d", d, i);
			yynerrs++;	//呼び出し元(main)に知らせるために。
			//全てのセマンティクスエラーを報告するために継続する。
		}
	}
	return i;
}
/*---------------------------------------------------------------------------*/
static ST_Inst* add_inst() {
	ST_Inst* pInst;
	if((unsigned)nInst >= Inst_Max) {
		yyerror("命令数が制限を超えました。(%d)", Inst_Max);
		exit(EXIT_FAILURE);
	}
	pInst = &TBL_Inst[nInst++];
	pInst->line = yylineno;		//行番号
	return pInst;
}
/*---------------------------------------------------------------------------*/
void inst_def(char* lab) {
	ENTRY item;
	item.key = (char*)lab;
	if(hsearch(item, FIND)) {
		yyerror("defのラベル定義が重複しています。(%s)", lab);
		yynerrs++;	//呼び出し元(main)に知らせるために。
		//全てのセマンティクスエラーを報告するために継続する。
	}
	item.data = (void*)nInst;
	if(!hsearch(item, ENTER)) {
		yyerror("ラベル数が制限を超えました。(%d)", Label_Max);
		yynerrs++;	//呼び出し元(main)に知らせるために。
		//全てのセマンティクスエラーを報告するために継続する。
	}
	if(nLabel < Label_Max) {
		TBL_Label[nLabel++] = lab;	//hsearch()はイテレーションの機能が無いので、後でイテレートするためにはキー配列を別に作成しておく必要が有る。
	}
	iRepeat = -1;		//ループ戻り位置の命令インデクスを無効にする。
}
/*---------------------------------------------------------------------------*/
void inst_repeat() {
	//waitの直後にrepeatが有る場合…(Sample/Sample.txtのSample4参照)
	ST_Inst* pInst;
	if((unsigned)nInst >= Inst_Max) {
		yyerror("命令数が制限を超えました。(%d)", Inst_Max);
		exit(EXIT_FAILURE);
	}
	pInst = &TBL_Inst[nInst];
	if(pInst->wait_cnt) {
		//repeatの直前のwaitはダミーの'event 0'にして、次の命令を生成しそれをrepeatの戻り先とする。
		//要するに、下記の【誤】の形になるのを避けて、【正】の形にするというわけです。
		//【誤】
		//		wait		10	←┐
		//	repeat				　│
		//		event		1	　│
		//		wait		20	　│
		//	end				─┘
		//【正】
		//		wait		10
		//		(event		0)
		//	repeat
		//		event		1	←┐	この下でadd_inst()する命令はこれに相当する。
		//		wait		20	　│
		//	end				─┘
		add_inst();
	}
	iRepeat = nInst;	//ループ戻り位置の命令インデクスを格納する。
}
/*---------------------------------------------------------------------------*/
void inst_end() {
	ST_Inst* pInst = add_inst();
	//ループ戻り位置の命令インデクスが無効ならば…	//def cmds end
	if(iRepeat == -1) {
		pInst->event_id = -1;		//end
	//ループ戻り位置の命令インデクスが有効ならば…	//def repeat cmds end,又は,def cmds repeat cmds end
	} else {
		//次の命令を基準として、ループ戻り位置の命令へのマイナス距離を求める。
		int dist = iRepeat - nInst;	//loop
		if((dist < SHRT_MIN) || (dist >= 0)) { DIE(); }	//距離が遠過ぎる,又は,バグ
		pInst->event_id = dist;
	}
	iRepeat = -1;		//ここで無効値(-1)を代入する事は必須ではない。endの次は(スクリプト終了でなければ)defが現れるはずでありdefで同じ処理を行うから。y.tab.yで検査されるのでwinapp.cが考慮する必要は無い。しかしデバッグし易さのためにここでも無効値(-1)を格納しておく事にした。
}
/*---------------------------------------------------------------------------*/
void inst_wait(int cnt) {
	ST_Inst* pInst;
	if((unsigned)nInst >= Inst_Max) {
		yyerror("命令数が制限を超えました。(%d)", Inst_Max);
		exit(EXIT_FAILURE);
	}
	pInst = &TBL_Inst[nInst];
    //{{2015/08/19変更:waitの引数に(2^16)以上の値も指定出来るようにしました。waitの引数に(2^16)以上の値を指定したり、複数のwaitの合計が(2^16)以上になったら、当ツールが自動的にダミーの'event 0'を含む複数の命令に展開します。
    //	if((unsigned)cnt > USHRT_MAX) {
    //		yyerror("waitの引数cntが範囲外です。(%d)", cnt);
    //		yynerrs++;	//呼び出し元(main)に知らせるために。
    //		//全てのセマンティクスエラーを報告するために継続する。
    //	} else if((unsigned)(pInst->wait_cnt + cnt) > USHRT_MAX) {
    //		yyerror("wait数が制限を超えました。(%d)", USHRT_MAX);
    //		yynerrs++;	//呼び出し元(main)に知らせるために。
    //		//全てのセマンティクスエラーを報告するために継続する。
    //	}
    //	pInst->wait_cnt += cnt;
    //↓2015/08/19変更:waitの引数に(2^16)以上の値も指定出来るようにしました。waitの引数に(2^16)以上の値を指定したり、複数のwaitの合計が(2^16)以上になったら、当ツールが自動的にダミーの'event 0'を含む複数の命令に展開します。
	if(cnt < 0) {
		yyerror("waitの引数cntが範囲外です。(%d)", cnt);
		yynerrs++;	//呼び出し元(main)に知らせるために。
		//全てのセマンティクスエラーを報告するために継続する。
	} else {
		//前のwait(有れば)と、今回のwaitの合計を求める。
		unsigned sum = pInst->wait_cnt + cnt;
		//waitの合計が((2^16)-1)超過ならば…
		while(sum > USHRT_MAX) {
			//waitが((2^16)-1)で'event 0'の、ダミー命令に分割する。
			pInst->wait_cnt = USHRT_MAX;
			add_inst();
			//次の命令のポインタを取得する。
			if((unsigned)nInst >= Inst_Max) {
				yyerror("命令数が制限を超えました。(%d)", Inst_Max);
				exit(EXIT_FAILURE);
			}
			pInst = &TBL_Inst[nInst];
			//waitの合計の残りを減らす。
			sum -= USHRT_MAX;
		}
		//waitの合計を((2^16)-1)に分割した余りを、次の命令に格納する。(0でも)
		//又は、waitの分割が発生しなかった場合は、元の命令に書き戻す。(0でも)
		pInst->wait_cnt = sum;
	}
    //}}2015/08/19変更:waitの引数に(2^16)以上の値も指定出来るようにしました。waitの引数に(2^16)以上の値を指定したり、複数のwaitの合計が(2^16)以上になったら、当ツールが自動的にダミーの'event 0'を含む複数の命令に展開します。
}
/*---------------------------------------------------------------------------*/
void inst_event(int id) {
	ST_Inst* pInst = add_inst();
	if((id < 1) || (id > SHRT_MAX)) {	//SHRT_MIN～(-2)=loop,(-1)=end,(0)=no_job,(1)～SHRT_MAX=event_id
		yyerror("eventの引数idが範囲外です。(%d)", id);
		yynerrs++;	//呼び出し元(main)に知らせるために。
		//全てのセマンティクスエラーを報告するために継続する。
	}
	pInst->event_id = id;	//event
}
/*---------------------------------------------------------------------------*/
//{{2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
void inst_event_name(char* name) {
	ST_Inst* pInst = add_inst();
	//イベント名が指定された場合は、1パス目ではevent_id=0のままとしておき、2パス目で各イベント名にID(1～)を割り振った後で、event_idを格納する。
	pInst->event_name = name;	//event
	{
		int iEvtName;
		for(iEvtName = 0; iEvtName < nEvtName; iEvtName++) {
			if(!strcmp(TBL_EvtName[iEvtName], name)) { break; }
		}
		if(iEvtName == nEvtName) {	//まだ登録されていなければ…
			if(nEvtName >= EvtName_Max) {
				yyerror("イベント名の数が制限を超えました。(%s)", name);
				DIE();	//継続しても無駄なので終了する。
			}
			TBL_EvtName[nEvtName++] = name;
		}
	}
}
//}}2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
/****************************************************************************
 *	2パス目の処理
 ****************************************************************************/
//{{2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
static int EvtName_compar(const void* x, const void* y) {
	return (*fnEvtCmp)(*(char**)x, *(char**)y);
}
//}}2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
/*---------------------------------------------------------------------------*/
static void pass2(int bOptimize) {
//{{2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
	int iInst;
	//イベント名を名前の昇順にソートする。
	qsort(TBL_EvtName, nEvtName, sizeof(char*), EvtName_compar);
	//全ての命令のイベント名を、イベントIDに変換する。
	for(iInst = 0; iInst < nInst; iInst++) {
		ST_Inst* pInst = &TBL_Inst[iInst];
		if(pInst->event_name) {
			int iEvtName;
			for(iEvtName = 0; iEvtName < nEvtName; iEvtName++) {
				if(!strcmp(TBL_EvtName[iEvtName], pInst->event_name)) { break; }
			}
			if(iEvtName == nEvtName) { DIE(); }	//バグ
			iEvtName++;	//イベント名に対するIDは1ベース
			pInst->event_id = iEvtName;
		}
	}
//}}2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
	//最適化を行う。
	if(bOptimize) { optimize(); }
}
/*---------------------------------------------------------------------------*/
static void optimize() {
	//2015/05/31現在、最適化処理は有りません。
	//今後、最適化機能を追加する場合のためのプレースホルダとして、関数のみ用意して有ります。
	//現在のところは、コマンドラインオプションに'-d'を指定してもしなくても違いは有りません。
}
/****************************************************************************
 *	出力処理
 ****************************************************************************/
static int Label_compar(const void* x, const void* y) {
	return (*fnLabCmp)(*(char**)x, *(char**)y);
}
/*---------------------------------------------------------------------------*/
static void output(char* sBinOut) {
//{{2016/10/10変更:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
//	int iInst, iLabel;
//↓2016/10/10変更:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
	int iInst, iLabel, iEvtName;
//}}2016/10/10変更:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
	ENTRY item, *pEntry;
	//ラベル定義を名前の昇順にソートする。
	qsort(TBL_Label, nLabel, sizeof(char*), Label_compar);
	//--- ラベルを標準出力に出力する ---
	for(iLabel = 0; iLabel < nLabel; iLabel++) {				//名前の昇順	ラベル=0(ダミー)は定義しない。
		char* label = TBL_Label[iLabel];
		printf("#define EvtTmrNo_%s %d\n", label, iLabel + 1);		//ラベルは1ベース
	}
	printf("#define EvtTmrNo_Max %d\n", nLabel);				//最大値
//{{2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
	//--- イベント名を標準出力に出力する ---
	for(iEvtName = 0; iEvtName < nEvtName; iEvtName++) {			//名前の昇順
		char* event_name = TBL_EvtName[iEvtName];
		printf("#define EvtId_%s %d\n", event_name, iEvtName + 1);	//イベント名に対するIDは1ベース
	}
	if(nEvtName) { printf("#define EvtId_Max %d\n", nEvtName); }		//イベント名指定による'event'が使用された場合のみ、イベント名に対するIDの最大値を出力する。
//}}2016/10/10追加:eventの引数として、イベントIDの直接指定だけでなく、イベント名も指定出来るようにしました。イベント名に対するIDは、当ツールが自動的に割り振ります。
	//--- データを出力する ---
	//バイナリ形式の場合…
	if(sBinOut) {
		FILE* fp = fopen(sBinOut, "wb");
		if(!fp) { error(EXIT_FAILURE, errno, "%s が作成できません。", sBinOut); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
		//アドレステーブルを出力する。
		for(iLabel = -1; iLabel < nLabel; iLabel++) {
			int addr;
			if(iLabel < 0) {
				addr = nLabel + 1;				//TBL_EvtTmrNo[0]=(EvtTmrNo_Max+1)	ラベルは1ベースなのでnLabelではなく(nLabel+1)とする事に注意せよ。
			} else {
				char* label = TBL_Label[iLabel];
				item.key = label;
				if(!(pEntry = hsearch(item, FIND))) { DIE(); }	//バグ
				addr = (int)pEntry->data;
			}
			fwrite(&addr, sizeof(int), 1, fp);
		}
		//命令コードの出力を行う。
		for(iInst = 0; iInst < nInst; iInst++) {
			ST_Inst* pInst = &TBL_Inst[iInst];
			int wait_cnt = pInst->wait_cnt;
			int event_id = pInst->event_id;
			fwrite(&wait_cnt, sizeof(unsigned short), 1, fp);
			fwrite(&event_id, sizeof(unsigned short), 1, fp);
		}
		fclose(fp);
	//テキスト形式の場合…
	} else {
		//アドレステーブルを出力する。
		printf("const int TBL_EvtTmrNo[%d]={", nLabel + 1);
		for(iLabel = -1; iLabel < nLabel; iLabel++) {
			int addr;
			if(iLabel < 0) {
				addr = nLabel + 1;				//TBL_EvtTmrNo[0]=(EvtTmrNo_Max+1)	ラベルは1ベースなのでnLabelではなく(nLabel+1)とする事に注意せよ。
			} else {
				char* label = TBL_Label[iLabel];
				item.key = label;
				if(!(pEntry = hsearch(item, FIND))) { DIE(); }	//バグ
				addr = (int)pEntry->data;
			}
			if((iLabel & 15) == 15)    { putchar('\n'); }
			printf("0x%08X", addr);
			if(iLabel != (nLabel - 1)) { putchar(',' ); }
		}
		puts("};");
		//命令コードの出力を行う。
		printf("const unsigned short TBL_EvtTmr[%d][2]={", nInst);
		for(iInst = 0; iInst < nInst; iInst++) {
			ST_Inst* pInst = &TBL_Inst[iInst];
			int wait_cnt = pInst->wait_cnt;
			int event_id = pInst->event_id;
			if(  iInst      ) { putchar(',' ); }
			if(!(iInst & 15)) { putchar('\n'); }
			printf("{0x%04X,0x%04X}", wait_cnt, event_id);
		}
		puts("};");
	}
}
